// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ds_autonomy_msgs:msg/LatLonPoint.idl
// generated code does not contain a copyright notice
#include "ds_autonomy_msgs/msg/detail/lat_lon_point__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


bool
ds_autonomy_msgs__msg__LatLonPoint__init(ds_autonomy_msgs__msg__LatLonPoint * msg)
{
  if (!msg) {
    return false;
  }
  // latitude
  // longitude
  return true;
}

void
ds_autonomy_msgs__msg__LatLonPoint__fini(ds_autonomy_msgs__msg__LatLonPoint * msg)
{
  if (!msg) {
    return;
  }
  // latitude
  // longitude
}

bool
ds_autonomy_msgs__msg__LatLonPoint__are_equal(const ds_autonomy_msgs__msg__LatLonPoint * lhs, const ds_autonomy_msgs__msg__LatLonPoint * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // latitude
  if (lhs->latitude != rhs->latitude) {
    return false;
  }
  // longitude
  if (lhs->longitude != rhs->longitude) {
    return false;
  }
  return true;
}

bool
ds_autonomy_msgs__msg__LatLonPoint__copy(
  const ds_autonomy_msgs__msg__LatLonPoint * input,
  ds_autonomy_msgs__msg__LatLonPoint * output)
{
  if (!input || !output) {
    return false;
  }
  // latitude
  output->latitude = input->latitude;
  // longitude
  output->longitude = input->longitude;
  return true;
}

ds_autonomy_msgs__msg__LatLonPoint *
ds_autonomy_msgs__msg__LatLonPoint__create()
{
  ds_autonomy_msgs__msg__LatLonPoint * msg = (ds_autonomy_msgs__msg__LatLonPoint *)malloc(sizeof(ds_autonomy_msgs__msg__LatLonPoint));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ds_autonomy_msgs__msg__LatLonPoint));
  bool success = ds_autonomy_msgs__msg__LatLonPoint__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ds_autonomy_msgs__msg__LatLonPoint__destroy(ds_autonomy_msgs__msg__LatLonPoint * msg)
{
  if (msg) {
    ds_autonomy_msgs__msg__LatLonPoint__fini(msg);
  }
  free(msg);
}


bool
ds_autonomy_msgs__msg__LatLonPoint__Sequence__init(ds_autonomy_msgs__msg__LatLonPoint__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ds_autonomy_msgs__msg__LatLonPoint * data = NULL;
  if (size) {
    data = (ds_autonomy_msgs__msg__LatLonPoint *)calloc(size, sizeof(ds_autonomy_msgs__msg__LatLonPoint));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ds_autonomy_msgs__msg__LatLonPoint__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ds_autonomy_msgs__msg__LatLonPoint__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ds_autonomy_msgs__msg__LatLonPoint__Sequence__fini(ds_autonomy_msgs__msg__LatLonPoint__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ds_autonomy_msgs__msg__LatLonPoint__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ds_autonomy_msgs__msg__LatLonPoint__Sequence *
ds_autonomy_msgs__msg__LatLonPoint__Sequence__create(size_t size)
{
  ds_autonomy_msgs__msg__LatLonPoint__Sequence * array = (ds_autonomy_msgs__msg__LatLonPoint__Sequence *)malloc(sizeof(ds_autonomy_msgs__msg__LatLonPoint__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ds_autonomy_msgs__msg__LatLonPoint__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ds_autonomy_msgs__msg__LatLonPoint__Sequence__destroy(ds_autonomy_msgs__msg__LatLonPoint__Sequence * array)
{
  if (array) {
    ds_autonomy_msgs__msg__LatLonPoint__Sequence__fini(array);
  }
  free(array);
}

bool
ds_autonomy_msgs__msg__LatLonPoint__Sequence__are_equal(const ds_autonomy_msgs__msg__LatLonPoint__Sequence * lhs, const ds_autonomy_msgs__msg__LatLonPoint__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ds_autonomy_msgs__msg__LatLonPoint__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ds_autonomy_msgs__msg__LatLonPoint__Sequence__copy(
  const ds_autonomy_msgs__msg__LatLonPoint__Sequence * input,
  ds_autonomy_msgs__msg__LatLonPoint__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ds_autonomy_msgs__msg__LatLonPoint);
    ds_autonomy_msgs__msg__LatLonPoint * data =
      (ds_autonomy_msgs__msg__LatLonPoint *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ds_autonomy_msgs__msg__LatLonPoint__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          ds_autonomy_msgs__msg__LatLonPoint__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ds_autonomy_msgs__msg__LatLonPoint__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
