// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ds_autonomy_msgs:msg/LonTarget.idl
// generated code does not contain a copyright notice
#include "ds_autonomy_msgs/msg/detail/lon_target__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
ds_autonomy_msgs__msg__LonTarget__init(ds_autonomy_msgs__msg__LonTarget * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ds_autonomy_msgs__msg__LonTarget__fini(msg);
    return false;
  }
  // target_type
  // rel_dist
  // rel_vel
  return true;
}

void
ds_autonomy_msgs__msg__LonTarget__fini(ds_autonomy_msgs__msg__LonTarget * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // target_type
  // rel_dist
  // rel_vel
}

bool
ds_autonomy_msgs__msg__LonTarget__are_equal(const ds_autonomy_msgs__msg__LonTarget * lhs, const ds_autonomy_msgs__msg__LonTarget * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // target_type
  if (lhs->target_type != rhs->target_type) {
    return false;
  }
  // rel_dist
  if (lhs->rel_dist != rhs->rel_dist) {
    return false;
  }
  // rel_vel
  if (lhs->rel_vel != rhs->rel_vel) {
    return false;
  }
  return true;
}

bool
ds_autonomy_msgs__msg__LonTarget__copy(
  const ds_autonomy_msgs__msg__LonTarget * input,
  ds_autonomy_msgs__msg__LonTarget * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // target_type
  output->target_type = input->target_type;
  // rel_dist
  output->rel_dist = input->rel_dist;
  // rel_vel
  output->rel_vel = input->rel_vel;
  return true;
}

ds_autonomy_msgs__msg__LonTarget *
ds_autonomy_msgs__msg__LonTarget__create()
{
  ds_autonomy_msgs__msg__LonTarget * msg = (ds_autonomy_msgs__msg__LonTarget *)malloc(sizeof(ds_autonomy_msgs__msg__LonTarget));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ds_autonomy_msgs__msg__LonTarget));
  bool success = ds_autonomy_msgs__msg__LonTarget__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ds_autonomy_msgs__msg__LonTarget__destroy(ds_autonomy_msgs__msg__LonTarget * msg)
{
  if (msg) {
    ds_autonomy_msgs__msg__LonTarget__fini(msg);
  }
  free(msg);
}


bool
ds_autonomy_msgs__msg__LonTarget__Sequence__init(ds_autonomy_msgs__msg__LonTarget__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ds_autonomy_msgs__msg__LonTarget * data = NULL;
  if (size) {
    data = (ds_autonomy_msgs__msg__LonTarget *)calloc(size, sizeof(ds_autonomy_msgs__msg__LonTarget));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ds_autonomy_msgs__msg__LonTarget__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ds_autonomy_msgs__msg__LonTarget__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ds_autonomy_msgs__msg__LonTarget__Sequence__fini(ds_autonomy_msgs__msg__LonTarget__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ds_autonomy_msgs__msg__LonTarget__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ds_autonomy_msgs__msg__LonTarget__Sequence *
ds_autonomy_msgs__msg__LonTarget__Sequence__create(size_t size)
{
  ds_autonomy_msgs__msg__LonTarget__Sequence * array = (ds_autonomy_msgs__msg__LonTarget__Sequence *)malloc(sizeof(ds_autonomy_msgs__msg__LonTarget__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ds_autonomy_msgs__msg__LonTarget__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ds_autonomy_msgs__msg__LonTarget__Sequence__destroy(ds_autonomy_msgs__msg__LonTarget__Sequence * array)
{
  if (array) {
    ds_autonomy_msgs__msg__LonTarget__Sequence__fini(array);
  }
  free(array);
}

bool
ds_autonomy_msgs__msg__LonTarget__Sequence__are_equal(const ds_autonomy_msgs__msg__LonTarget__Sequence * lhs, const ds_autonomy_msgs__msg__LonTarget__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ds_autonomy_msgs__msg__LonTarget__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ds_autonomy_msgs__msg__LonTarget__Sequence__copy(
  const ds_autonomy_msgs__msg__LonTarget__Sequence * input,
  ds_autonomy_msgs__msg__LonTarget__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ds_autonomy_msgs__msg__LonTarget);
    ds_autonomy_msgs__msg__LonTarget * data =
      (ds_autonomy_msgs__msg__LonTarget *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ds_autonomy_msgs__msg__LonTarget__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          ds_autonomy_msgs__msg__LonTarget__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ds_autonomy_msgs__msg__LonTarget__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
