// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ds_autonomy_msgs:srv/SetSpeedConstraints.idl
// generated code does not contain a copyright notice

#ifndef DS_AUTONOMY_MSGS__SRV__DETAIL__SET_SPEED_CONSTRAINTS__TRAITS_HPP_
#define DS_AUTONOMY_MSGS__SRV__DETAIL__SET_SPEED_CONSTRAINTS__TRAITS_HPP_

#include "ds_autonomy_msgs/srv/detail/set_speed_constraints__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const ds_autonomy_msgs::srv::SetSpeedConstraints_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: speed_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_limit: ";
    value_to_yaml(msg.speed_limit, out);
    out << "\n";
  }

  // member: lateral_accel_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lateral_accel_limit: ";
    value_to_yaml(msg.lateral_accel_limit, out);
    out << "\n";
  }

  // member: linear_accel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linear_accel: ";
    value_to_yaml(msg.linear_accel, out);
    out << "\n";
  }

  // member: linear_decel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "linear_decel: ";
    value_to_yaml(msg.linear_decel, out);
    out << "\n";
  }

  // member: jerk_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "jerk_limit: ";
    value_to_yaml(msg.jerk_limit, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ds_autonomy_msgs::srv::SetSpeedConstraints_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>()
{
  return "ds_autonomy_msgs::srv::SetSpeedConstraints_Request";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>()
{
  return "ds_autonomy_msgs/srv/SetSpeedConstraints_Request";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const ds_autonomy_msgs::srv::SetSpeedConstraints_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: actual_speed_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "actual_speed_limit: ";
    value_to_yaml(msg.actual_speed_limit, out);
    out << "\n";
  }

  // member: actual_lateral_accel_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "actual_lateral_accel_limit: ";
    value_to_yaml(msg.actual_lateral_accel_limit, out);
    out << "\n";
  }

  // member: actual_linear_accel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "actual_linear_accel: ";
    value_to_yaml(msg.actual_linear_accel, out);
    out << "\n";
  }

  // member: actual_linear_decel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "actual_linear_decel: ";
    value_to_yaml(msg.actual_linear_decel, out);
    out << "\n";
  }

  // member: actual_jerk_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "actual_jerk_limit: ";
    value_to_yaml(msg.actual_jerk_limit, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ds_autonomy_msgs::srv::SetSpeedConstraints_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>()
{
  return "ds_autonomy_msgs::srv::SetSpeedConstraints_Response";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>()
{
  return "ds_autonomy_msgs/srv/SetSpeedConstraints_Response";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<ds_autonomy_msgs::srv::SetSpeedConstraints>()
{
  return "ds_autonomy_msgs::srv::SetSpeedConstraints";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::SetSpeedConstraints>()
{
  return "ds_autonomy_msgs/srv/SetSpeedConstraints";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::SetSpeedConstraints>
  : std::integral_constant<
    bool,
    has_fixed_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>::value &&
    has_fixed_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>::value
  >
{
};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints>
  : std::integral_constant<
    bool,
    has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>::value &&
    has_bounded_size<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>::value
  >
{
};

template<>
struct is_service<ds_autonomy_msgs::srv::SetSpeedConstraints>
  : std::true_type
{
};

template<>
struct is_service_request<ds_autonomy_msgs::srv::SetSpeedConstraints_Request>
  : std::true_type
{
};

template<>
struct is_service_response<ds_autonomy_msgs::srv::SetSpeedConstraints_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // DS_AUTONOMY_MSGS__SRV__DETAIL__SET_SPEED_CONSTRAINTS__TRAITS_HPP_
