// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ds_autonomy_msgs:srv/LoadNetwork.idl
// generated code does not contain a copyright notice

#ifndef DS_AUTONOMY_MSGS__SRV__DETAIL__LOAD_NETWORK__TRAITS_HPP_
#define DS_AUTONOMY_MSGS__SRV__DETAIL__LOAD_NETWORK__TRAITS_HPP_

#include "ds_autonomy_msgs/srv/detail/load_network__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const ds_autonomy_msgs::srv::LoadNetwork_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: drn_data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.drn_data.size() == 0) {
      out << "drn_data: []\n";
    } else {
      out << "drn_data:\n";
      for (auto item : msg.drn_data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ds_autonomy_msgs::srv::LoadNetwork_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<ds_autonomy_msgs::srv::LoadNetwork_Request>()
{
  return "ds_autonomy_msgs::srv::LoadNetwork_Request";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::LoadNetwork_Request>()
{
  return "ds_autonomy_msgs/srv/LoadNetwork_Request";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::LoadNetwork_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::LoadNetwork_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<ds_autonomy_msgs::srv::LoadNetwork_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'latlon_points'
#include "ds_autonomy_msgs/msg/detail/lat_lon_point__traits.hpp"
// Member 'cartesian_points'
#include "geometry_msgs/msg/detail/point__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const ds_autonomy_msgs::srv::LoadNetwork_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: latlon_points
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.latlon_points.size() == 0) {
      out << "latlon_points: []\n";
    } else {
      out << "latlon_points:\n";
      for (auto item : msg.latlon_points) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: cartesian_points
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.cartesian_points.size() == 0) {
      out << "cartesian_points: []\n";
    } else {
      out << "cartesian_points:\n";
      for (auto item : msg.cartesian_points) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ds_autonomy_msgs::srv::LoadNetwork_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<ds_autonomy_msgs::srv::LoadNetwork_Response>()
{
  return "ds_autonomy_msgs::srv::LoadNetwork_Response";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::LoadNetwork_Response>()
{
  return "ds_autonomy_msgs/srv/LoadNetwork_Response";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::LoadNetwork_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::LoadNetwork_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<ds_autonomy_msgs::srv::LoadNetwork_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<ds_autonomy_msgs::srv::LoadNetwork>()
{
  return "ds_autonomy_msgs::srv::LoadNetwork";
}

template<>
inline const char * name<ds_autonomy_msgs::srv::LoadNetwork>()
{
  return "ds_autonomy_msgs/srv/LoadNetwork";
}

template<>
struct has_fixed_size<ds_autonomy_msgs::srv::LoadNetwork>
  : std::integral_constant<
    bool,
    has_fixed_size<ds_autonomy_msgs::srv::LoadNetwork_Request>::value &&
    has_fixed_size<ds_autonomy_msgs::srv::LoadNetwork_Response>::value
  >
{
};

template<>
struct has_bounded_size<ds_autonomy_msgs::srv::LoadNetwork>
  : std::integral_constant<
    bool,
    has_bounded_size<ds_autonomy_msgs::srv::LoadNetwork_Request>::value &&
    has_bounded_size<ds_autonomy_msgs::srv::LoadNetwork_Response>::value
  >
{
};

template<>
struct is_service<ds_autonomy_msgs::srv::LoadNetwork>
  : std::true_type
{
};

template<>
struct is_service_request<ds_autonomy_msgs::srv::LoadNetwork_Request>
  : std::true_type
{
};

template<>
struct is_service_response<ds_autonomy_msgs::srv::LoadNetwork_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // DS_AUTONOMY_MSGS__SRV__DETAIL__LOAD_NETWORK__TRAITS_HPP_
